
local gr	= love.graphics
local pi, sin, cos, atan2, abs = math.pi, math.sin, math.cos, math.atan2, math.abs

function love.load()
	shade 		= require 'shade'
	createLight()
	bg		= gr.newImage( 'background.png' )
	ms		= gr.newImage( 'car1.png' )
	lena = gr.newImage( 'lenaC.jpg' )
	canvas	= gr.newCanvas( bg:getWidth(), bg:getHeight() )
	quads	= {}
	size	= 75
	for i	= 1, 5 do
		quads[i] = gr.newQuad( size*(i-1), 200, size, size, lena:getWidth(), lena:getHeight() )
		end
	cans	= {}
	for i	= 1, #quads do
	cans[i] = gr.newCanvas( size, size )
	gr.setCanvas( cans[i] )
		gr.draw( lena, quads[i] )
		gr.setCanvas()
	end
	gr.setCanvas( canvas )
		gr.draw( bg )
		gr.draw( lena, 400, 300, 0, 1, 1, lena:getWidth()/2, lena:getHeight()/2 )
		gr.setCanvas()
	an, r, c = 0, 200, { 400, 300 }
	end

function love.update( dt )
	an				= an+dt
	light.param.x	= r * math.cos( an ) + c[1]
	light.param.y	= r * math.sin( an ) + c[2]
	x				= r * math.cos( an - 30 * dt ) + c[1]
	y				= r * math.sin( an - 30 * dt ) + c[2]
	shade:send( 'x', light.param.x / 800 )
	shade:send( 'y', light.param.y / 600 )
	end

function love.draw()
	gr.setShader( shade )
		gr.draw( bg, 400, 300, 0, 1, 1, bg:getWidth()/2, bg:getHeight()/2 )
		gr.draw( lena, 400, 300, 0, 1, 1, lena:getWidth()/2, lena:getHeight()/2 )
		for i=1,#cans do gr.draw(cans[i],(i-1)*(size+20),50) end
		gr.setShader()
	gr.draw( ms, x, y, an - math.pi/2, 1, 1, ms:getWidth()/2, ms:getHeight()/2 )
	love.window.setTitle( 'Light Test - fps: '..love.timer.getFPS( ) )
	end

function love.keypressed( key )
	if key == 'escape'	then love.event.quit() 	end
	if key == 'up'		then light.param.y=light.param.y-.05 end
	if key == 'down'	then light.param.y=light.param.y+.05 end
	if key == 'left'	then light.param.x=light.param.x-.05 end
	if key == 'right'	then light.param.x=light.param.x+.05 end
	if key == 'w'		then light.param.size=light.param.size+.05 end
	if key == 's'		then light.param.size=light.param.size-.05 end
	for i, j in pairs( light.param ) do shade:send( i, j ) end
	end

function createLight()
	light 		= {
		dur		= 0.04,
		cur		= 0.0,
		an		= 0.0,
		anim	= true,
		param	= { x = 0.50, y = 0.50, size = .5,aspect=800/600 },
		rot		= function( self, a )
			self.param.x = 0.5 * math.cos(a) + 0.5
			self.param.y = 0.5 * math.sin(a) + 0.5
			for i, j in pairs( self.param ) do shade:send( i, j ) end
			end,
		update = function( self, t )
			if self.anim then
				self.cur = self.cur + t
				if self.cur > self.dur then
					self.cur = 0
					self.an = self.an+10*t
					self:rot( self.an )
					end
				end
			end,
		}
	for i, j in pairs( light.param ) do shade:send( i, j ) end	-- initial settings
	end

